import{s as Le,n as we,o as Te}from"../chunks/scheduler.9680c161.js";import{S as Ce,i as $e,g as s,s as i,r as W,A as be,h as o,f as n,c as a,j as ye,u as X,x as u,k as _e,y as He,a as l,v as Z,d as ee,t as te,w as ne}from"../chunks/index.38d74ee1.js";import{H as le}from"../chunks/Heading.74c51a96.js";function Pe(ie){let r,k,H,I,m,S,f,ae=`Speculative decoding, assisted generation, Medusa, and others are a few different names for the same idea.
The idea is to generate tokens <em>before</em> the large model actually runs, and only <em>check</em> if those tokens where valid.`,q,p,se="So you are making <em>more</em> computations on your LLM, but if you are correct you produce 1, 2, 3 etc.. tokens on a single LLM pass. Since LLMs are usually memory bound (and not compute bound), provided your guesses are correct enough, this is a 2-3x faster inference (It can be much more for code oriented tasks for instance).",j,c,oe='You can check a more <a href="https://huggingface.co/blog/assisted-generation" rel="nofollow">detailed explanation</a>.',z,d,ue="Text-generation inference supports 2 main speculative methods:",B,h,re="<li>Medusa</li> <li>N-gram</li>",E,v,N,x,me='Medusa is a <a href="https://arxiv.org/abs/2401.10774" rel="nofollow">simple method</a> to create many tokens in a single pass using fine-tuned LM heads in addition to your existing models.',D,g,fe="You can check a few existing  fine-tunes for popular models:",U,M,pe='<li><a href="https://huggingface.co/text-generation-inference/gemma-7b-it-medusa" rel="nofollow">text-generation-inference/gemma-7b-it-medusa</a></li> <li><a href="https://huggingface.co/text-generation-inference/Mixtral-8x7B-Instruct-v0.1-medusa" rel="nofollow">text-generation-inference/Mixtral-8x7B-Instruct-v0.1-medusa</a></li> <li><a href="https://huggingface.co/text-generation-inference/Mistral-7B-Instruct-v0.2-medusa" rel="nofollow">text-generation-inference/Mistral-7B-Instruct-v0.2-medusa</a></li>',A,y,ce='In order to create your own medusa heads for your own finetune, you should check own the original medusa repo. <a href="https://github.com/FasterDecoding/Medusa" rel="nofollow">https://github.com/FasterDecoding/Medusa</a>',F,_,de="In order to use medusa models in TGI, simply point to a medusa enabled model, and everything will load automatically.",Y,L,G,w,he=`If you don’t have a medusa model, or don’t have the resource to fine-tune, you can try to use <code>n-gram</code>.
Ngram works by trying to find in the previous sequence existing tokens that match, and use those as speculation.`,R,T,ve="This is an extremely simple method, which works best for code, or highly repetitive text. This might not be beneficial, if the speculation misses too much.",J,C,xe="In order to enable n-gram speculation simply use",K,$,ge="<code>--speculate 2</code> in your flags.",O,b,Me='<a href="https://huggingface.co/docs/text-generation-inference/basic_tutorials/launcher#speculate" rel="nofollow">Details about the flag</a>',Q,P,V;return m=new le({props:{title:"Speculation",local:"speculation",headingTag:"h2"}}),v=new le({props:{title:"Medusa",local:"medusa",headingTag:"h3"}}),L=new le({props:{title:"N-gram",local:"n-gram",headingTag:"h3"}}),{c(){r=s("meta"),k=i(),H=s("p"),I=i(),W(m.$$.fragment),S=i(),f=s("p"),f.innerHTML=ae,q=i(),p=s("p"),p.innerHTML=se,j=i(),c=s("p"),c.innerHTML=oe,z=i(),d=s("p"),d.textContent=ue,B=i(),h=s("ul"),h.innerHTML=re,E=i(),W(v.$$.fragment),N=i(),x=s("p"),x.innerHTML=me,D=i(),g=s("p"),g.textContent=fe,U=i(),M=s("ul"),M.innerHTML=pe,A=i(),y=s("p"),y.innerHTML=ce,F=i(),_=s("p"),_.textContent=de,Y=i(),W(L.$$.fragment),G=i(),w=s("p"),w.innerHTML=he,R=i(),T=s("p"),T.textContent=ve,J=i(),C=s("p"),C.textContent=xe,K=i(),$=s("p"),$.innerHTML=ge,O=i(),b=s("p"),b.innerHTML=Me,Q=i(),P=s("p"),this.h()},l(e){const t=be("svelte-u9bgzb",document.head);r=o(t,"META",{name:!0,content:!0}),t.forEach(n),k=a(e),H=o(e,"P",{}),ye(H).forEach(n),I=a(e),X(m.$$.fragment,e),S=a(e),f=o(e,"P",{"data-svelte-h":!0}),u(f)!=="svelte-17a28u5"&&(f.innerHTML=ae),q=a(e),p=o(e,"P",{"data-svelte-h":!0}),u(p)!=="svelte-1tzgo4g"&&(p.innerHTML=se),j=a(e),c=o(e,"P",{"data-svelte-h":!0}),u(c)!=="svelte-qhbwif"&&(c.innerHTML=oe),z=a(e),d=o(e,"P",{"data-svelte-h":!0}),u(d)!=="svelte-1sqs0g7"&&(d.textContent=ue),B=a(e),h=o(e,"UL",{"data-svelte-h":!0}),u(h)!=="svelte-1d4jtwt"&&(h.innerHTML=re),E=a(e),X(v.$$.fragment,e),N=a(e),x=o(e,"P",{"data-svelte-h":!0}),u(x)!=="svelte-1j9vs1z"&&(x.innerHTML=me),D=a(e),g=o(e,"P",{"data-svelte-h":!0}),u(g)!=="svelte-85cbh3"&&(g.textContent=fe),U=a(e),M=o(e,"UL",{"data-svelte-h":!0}),u(M)!=="svelte-m7tzce"&&(M.innerHTML=pe),A=a(e),y=o(e,"P",{"data-svelte-h":!0}),u(y)!=="svelte-f381yp"&&(y.innerHTML=ce),F=a(e),_=o(e,"P",{"data-svelte-h":!0}),u(_)!=="svelte-x0oydl"&&(_.textContent=de),Y=a(e),X(L.$$.fragment,e),G=a(e),w=o(e,"P",{"data-svelte-h":!0}),u(w)!=="svelte-1t85c9w"&&(w.innerHTML=he),R=a(e),T=o(e,"P",{"data-svelte-h":!0}),u(T)!=="svelte-1nvhqv5"&&(T.textContent=ve),J=a(e),C=o(e,"P",{"data-svelte-h":!0}),u(C)!=="svelte-nu16xj"&&(C.textContent=xe),K=a(e),$=o(e,"P",{"data-svelte-h":!0}),u($)!=="svelte-1wnslsy"&&($.innerHTML=ge),O=a(e),b=o(e,"P",{"data-svelte-h":!0}),u(b)!=="svelte-1aes5um"&&(b.innerHTML=Me),Q=a(e),P=o(e,"P",{}),ye(P).forEach(n),this.h()},h(){_e(r,"name","hf:doc:metadata"),_e(r,"content",ke)},m(e,t){He(document.head,r),l(e,k,t),l(e,H,t),l(e,I,t),Z(m,e,t),l(e,S,t),l(e,f,t),l(e,q,t),l(e,p,t),l(e,j,t),l(e,c,t),l(e,z,t),l(e,d,t),l(e,B,t),l(e,h,t),l(e,E,t),Z(v,e,t),l(e,N,t),l(e,x,t),l(e,D,t),l(e,g,t),l(e,U,t),l(e,M,t),l(e,A,t),l(e,y,t),l(e,F,t),l(e,_,t),l(e,Y,t),Z(L,e,t),l(e,G,t),l(e,w,t),l(e,R,t),l(e,T,t),l(e,J,t),l(e,C,t),l(e,K,t),l(e,$,t),l(e,O,t),l(e,b,t),l(e,Q,t),l(e,P,t),V=!0},p:we,i(e){V||(ee(m.$$.fragment,e),ee(v.$$.fragment,e),ee(L.$$.fragment,e),V=!0)},o(e){te(m.$$.fragment,e),te(v.$$.fragment,e),te(L.$$.fragment,e),V=!1},d(e){e&&(n(k),n(H),n(I),n(S),n(f),n(q),n(p),n(j),n(c),n(z),n(d),n(B),n(h),n(E),n(N),n(x),n(D),n(g),n(U),n(M),n(A),n(y),n(F),n(_),n(Y),n(G),n(w),n(R),n(T),n(J),n(C),n(K),n($),n(O),n(b),n(Q),n(P)),n(r),ne(m,e),ne(v,e),ne(L,e)}}}const ke='{"title":"Speculation","local":"speculation","sections":[{"title":"Medusa","local":"medusa","sections":[],"depth":3},{"title":"N-gram","local":"n-gram","sections":[],"depth":3}],"depth":2}';function Ie(ie){return Te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ze extends Ce{constructor(r){super(),$e(this,r,Ie,Pe,Le,{})}}export{ze as component};
